diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/examples/wireless/wifi-vht-network.cc ns-3.46/examples/wireless/wifi-vht-network.cc
--- ns-3.45/examples/wireless/wifi-vht-network.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/examples/wireless/wifi-vht-network.cc	2025-10-01 18:46:32.000000000 -0700
@@ -17,6 +17,7 @@
 #include "ns3/log.h"
 #include "ns3/mobility-helper.h"
 #include "ns3/multi-model-spectrum-channel.h"
+#include "ns3/neighbor-cache-helper.h"
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
 #include "ns3/packet-sink.h"
@@ -27,6 +28,7 @@
 #include "ns3/udp-server.h"
 #include "ns3/uinteger.h"
 #include "ns3/vht-phy.h"
+#include "ns3/wifi-static-setup-helper.h"
 #include "ns3/yans-wifi-channel.h"
 #include "ns3/yans-wifi-helper.h"
 
@@ -61,6 +63,8 @@
     bool useRts{false};
     bool use80Plus80{false};
     Time simulationTime{"10s"};
+    bool staticSetup{true};
+    auto clientAppStartTime = Seconds(1);
     meter_u distance{1.0};
     std::string mcsStr;
     std::vector<uint64_t> mcsValues;
@@ -71,6 +75,9 @@
     double maxExpectedThroughput{0.0};
 
     CommandLine cmd(__FILE__);
+    cmd.AddValue("staticSetup",
+                 "Whether devices are configured using the static setup helper",
+                 staticSetup);
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
@@ -247,6 +254,8 @@
                     mac.SetType("ns3::ApWifiMac",
                                 "EnableBeaconJitter",
                                 BooleanValue(false),
+                                "BeaconGeneration",
+                                BooleanValue(!staticSetup),
                                 "Ssid",
                                 SsidValue(ssid));
                     apDevice = wifi.Install(phy, mac, wifiApNode);
@@ -289,6 +298,16 @@
                 mobility.Install(wifiApNode);
                 mobility.Install(wifiStaNode);
 
+                if (staticSetup)
+                {
+                    /* static setup of association and BA agreements */
+                    auto apDev = DynamicCast<WifiNetDevice>(apDevice.Get(0));
+                    NS_ASSERT(apDev);
+                    WifiStaticSetupHelper::SetStaticAssociation(apDev, staDevice);
+                    WifiStaticSetupHelper::SetStaticBlockAck(apDev, staDevice, {0});
+                    clientAppStartTime = MilliSeconds(1);
+                }
+
                 /* Internet stack*/
                 InternetStackHelper stack;
                 stack.Install(wifiApNode);
@@ -304,6 +323,13 @@
                 staNodeInterface = address.Assign(staDevice);
                 apNodeInterface = address.Assign(apDevice);
 
+                if (staticSetup)
+                {
+                    /* static setup of ARP cache */
+                    NeighborCacheHelper nbCache;
+                    nbCache.PopulateNeighborCache();
+                }
+
                 /* Setting applications */
                 const auto maxLoad = VhtPhy::GetDataRate(mcs,
                                                          MHz_u{static_cast<double>(width)},
@@ -319,7 +345,7 @@
                     streamNumber += server.AssignStreams(wifiStaNode.Get(0), streamNumber);
 
                     serverApp.Start(Seconds(0));
-                    serverApp.Stop(simulationTime + Seconds(1));
+                    serverApp.Stop(simulationTime + clientAppStartTime);
                     const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                     UdpClientHelper client(staNodeInterface.GetAddress(0), port);
@@ -329,8 +355,8 @@
                     ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
                     streamNumber += client.AssignStreams(wifiApNode.Get(0), streamNumber);
 
-                    clientApp.Start(Seconds(1));
-                    clientApp.Stop(simulationTime + Seconds(1));
+                    clientApp.Start(clientAppStartTime);
+                    clientApp.Stop(simulationTime + clientAppStartTime);
                 }
                 else
                 {
@@ -343,7 +369,7 @@
                         packetSinkHelper.AssignStreams(wifiStaNode.Get(0), streamNumber);
 
                     serverApp.Start(Seconds(0));
-                    serverApp.Stop(simulationTime + Seconds(1));
+                    serverApp.Stop(simulationTime + clientAppStartTime);
 
                     OnOffHelper onoff("ns3::TcpSocketFactory", Ipv4Address::GetAny());
                     onoff.SetAttribute("OnTime",
@@ -358,13 +384,13 @@
                     ApplicationContainer clientApp = onoff.Install(wifiApNode.Get(0));
                     streamNumber += onoff.AssignStreams(wifiApNode.Get(0), streamNumber);
 
-                    clientApp.Start(Seconds(1));
-                    clientApp.Stop(simulationTime + Seconds(1));
+                    clientApp.Start(clientAppStartTime);
+                    clientApp.Stop(simulationTime + clientAppStartTime);
                 }
 
                 Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
-                Simulator::Stop(simulationTime + Seconds(1));
+                Simulator::Stop(simulationTime + clientAppStartTime);
                 Simulator::Run();
 
                 auto rxBytes = 0.0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/ns3 ns-3.46/ns3
--- ns-3.45/ns3	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/ns3	2025-10-01 18:46:32.000000000 -0700
@@ -26,6 +26,11 @@
 path_sep = ";" if ";" in os.environ["PATH"] else ":"
 path_variable = "$PATH" if path_sep == ":" else "%PATH%"
 
+try:
+    TERMINAL_WIDTH = os.get_terminal_size().columns
+except OSError:
+    TERMINAL_WIDTH = 80  # assume 80 columns when grepping
+
 
 # Prints everything in the print_buffer on exit
 def exit_handler(dry_run):
@@ -107,6 +112,19 @@
         default=None,
         dest="main_help",
     )
+    parser.add_argument(
+        "--compile-or-die",
+        help=(
+            "Build and test each individual commit between a base and an head commits.\n"
+            "This is especially useful when preparing MRs or rewriting git history, and ensuring refactor-or-die "
+            "principle is being followed"
+        ),
+        action="store",
+        nargs=2,
+        type=str,
+        default=[None, None],
+        metavar="compile_or_die",
+    )
     parser_help = sub_parser.add_parser("help", help="Print a summary of available commands")
     parser_help.add_argument(
         "help", help="Print a summary of available commands", action="store_true", default=False
@@ -166,7 +184,11 @@
     )
 
     parser_configure.add_argument(
-        "--cxx-standard", help="Compile NS-3 with the given C++ standard", type=str, default=None
+        "--cxx-standard",
+        help="Compile NS-3 with the given C++ standard",
+        type=str,
+        default=None,
+        choices=["23", "26"],
     )
 
     # On-Off options
@@ -218,7 +240,7 @@
     )
     parser_configure.add_argument(
         "--disable-modules",
-        help='List of modules not to build (e.g. "lte;wimax")',
+        help='List of modules not to build (e.g. "lte;wifi")',
         action="store",
         type=str,
         default=None,
@@ -520,7 +542,7 @@
             if custom_exit in e.message:
                 error_message = f"Exiting due to {e.message[e.message.index(custom_exit):]}"
         # Format error message to better fit the terminal width
-        print("\n".join(textwrap.wrap(error_message, width=os.get_terminal_size().columns)))
+        print("\n".join(textwrap.wrap(error_message, width=TERMINAL_WIDTH)))
         exit(1)
 
     # If run doesn't have a target, print the help message of the run parser
@@ -1179,8 +1201,6 @@
     current_settings.extend(re.findall("(CMAKE_GENERATOR):.*=(.*)", contents))  # extract generator
     current_settings.extend(re.findall("(CMAKE_CXX_COMPILER):.*=(.*)", contents))  # C++ compiler
     current_settings.extend(re.findall("(CMAKE_CXX_FLAGS):.*=(.*)", contents))  # C++ flags
-    current_settings.extend(re.findall("(CMAKE_C_COMPILER):.*=(.*)", contents))  # C compiler
-    current_settings.extend(re.findall("(CMAKE_C_FLAGS):.*=(.*)", contents))  # C flags
     current_settings.extend(
         re.findall("(CMAKE_INSTALL_PREFIX):.*=(.*)", contents)
     )  # installation directory
@@ -1505,12 +1525,12 @@
             # running mpi on the CI?
             if target_to_run in ["mpiexec", "mpirun"] and os.getenv("MPI_CI"):
                 if shutil.which("ompi_info"):
-                    target_args = ["--oversubscribe"] + target_args
                     try:
                         subprocess.check_call([target_to_run, "--allow-run-as-root", "dir"])
                         target_args = ["--allow-run-as-root"] + target_args
                     except subprocess.CalledProcessError:
                         pass
+                    target_args = ["--oversubscribe"] + target_args
 
     program_arguments = [*debugging_software, target_to_run, *target_args]
 
@@ -1571,11 +1591,7 @@
     def list_to_table(targets_list: list) -> str:
         # Set column width and check how much is space is left at the end
         columnwidth = 30
-        try:
-            terminal_width = os.get_terminal_size().columns
-        except OSError:
-            terminal_width = 80  # assume 80 columns when grepping
-        dead_space = terminal_width % columnwidth
+        dead_space = TERMINAL_WIDTH % columnwidth
 
         # Filter the targets with names longer than the column width
         large_items = list(filter(lambda x: len(x) >= columnwidth, targets_list))
@@ -1589,7 +1605,7 @@
             current_end = len(output)
             # If the terminal width minus the written columns is smaller than the dead space,
             # we add a new line and start counting the width of the new line from it
-            if terminal_width - (current_end - prev_new_line) < dead_space:
+            if TERMINAL_WIDTH - (current_end - prev_new_line) < dead_space:
                 prev_new_line = len(output)
                 output += "\n"
             # After the new line or space, add the item plus some spacing
@@ -1655,6 +1671,121 @@
         exit(0)
 
 
+def compile_or_die(base_commit, head_commit):
+    try:
+        import git.exc
+        from git import Repo
+    except ImportError:
+        raise Exception("Missing pip package 'GitPython'.")
+
+    if shutil.which("git") is None:
+        raise Exception("Missing program 'git'.")
+
+    # Load ns-3 and module git repositories
+    NS3_DIR = os.path.abspath(os.path.dirname(__file__))
+    SRC_DIR = os.path.join(NS3_DIR, "src")
+    CONTRIB_DIR = os.path.join(NS3_DIR, "contrib")
+    git_repos_dirs = [NS3_DIR]
+    git_repos_dirs.extend(map(lambda x: os.path.join(SRC_DIR, x), os.listdir(SRC_DIR)))
+    git_repos_dirs.extend(map(lambda x: os.path.join(CONTRIB_DIR, x), os.listdir(CONTRIB_DIR)))
+    git_repos_dirs = list(filter(lambda x: os.path.isdir(x), git_repos_dirs))
+    git_repos_dirs = list(filter(lambda x: os.path.exists(os.path.join(x, ".git")), git_repos_dirs))
+    git_repos = []
+    for repo_dir in git_repos_dirs:
+        try:
+            git_repos.append(Repo(repo_dir))
+        except Exception as e:
+            raise Exception(f"Failed to load git repository in {repo_dir}: {e}")
+
+    # Check which particular repo we are testing (contain both base and top commits)
+    tested_repo = None
+    commits = None
+    for git_repo in git_repos:
+        commits = list(git_repo.iter_commits(all=True))
+        base_commit_object = list(filter(lambda x: x.hexsha == base_commit, commits))
+        head_commit_object = list(filter(lambda x: x.hexsha == head_commit, commits))
+        if base_commit_object and head_commit_object:
+            tested_repo = git_repo
+            break
+
+    if not tested_repo:
+        raise Exception("Base and head commits were not found in any of the git repositories")
+
+    # Filter commits we want to test
+    commits_sha = list(map(lambda x: x.hexsha, commits))
+    commits = commits[commits_sha.index(head_commit) : commits_sha.index(base_commit) + 1]
+
+    # Check if there are uncommitted changes, that will be lost if we proceed
+    diff = tested_repo.git.diff()
+    if diff:
+        print(
+            "Interrupted compile-or-die testing to prevent data loss."
+            "Uncommitted changes were found. Commit them or remove them before proceeding."
+        )
+        exit(-1)
+
+    # Check if head commit has a branch attached to it
+    branches_with_head_commit = list(
+        filter(
+            lambda x: x.commit.hexsha == head_commit and x.name != "compileOrDieTest",
+            list(tested_repo.branches),
+        )
+    )
+    if not branches_with_head_commit:
+        # If not, then create one (compileOrDieBackup), otherwise we could lose data
+        compile_or_die_backup_branch = list(
+            filter(lambda x: x.name == "compileOrDieBackup", list(tested_repo.branches))
+        )
+        if not compile_or_die_backup_branch:
+            # If the backup branch does not exist, we can safely create it
+            tested_repo.create_head("compileOrDieBackup", commits[0]).checkout()
+        else:
+            # If the backup branch already exist, we actually need to check if there
+            # is another branch attached to it, otherwise we could lose data
+            branches_of_backup = list(
+                filter(
+                    lambda x: x.commit.hexsha == compile_or_die_backup_branch.commit.hexsha,
+                    list(tested_repo.branches),
+                )
+            )
+            if len(branches_of_backup) == 1:
+                print(
+                    "Interrupted compile-or-die testing to prevent data loss."
+                    "Make sure the head commit of the compileOrDieBackup branch has a second branch attached to it."
+                )
+                exit(-1)
+            compile_or_die_backup_branch[0].set_commit(commits[0])
+            compile_or_die_backup_branch[0].checkout()
+            compile_or_die_backup_branch[0].repo.git.reset("--hard")
+
+    # Checkout the test branch
+    compile_or_die_test_branch = tested_repo.create_head("compileOrDieTest")
+
+    # Reset the test branch to a specific commit, then hard reset it
+    # From oldest to newest
+    commits = list(reversed(commits))
+    print(f"Compile-or-die with commits: {list(map(lambda x: x.hexsha, commits))}")
+    for commit in commits:
+        print(f"\tTesting commit {commit.hexsha}")
+        compile_or_die_test_branch.set_commit(commit)
+        compile_or_die_test_branch.checkout()
+        compile_or_die_test_branch.repo.git.reset("--hard")
+        try:
+            ret = subprocess.run(
+                [sys.executable, "./test.py", "--verbose-failed"],
+                cwd=ns3_path,
+                capture_output=True,
+                shell=False,
+            )
+            if ret.returncode != 0:
+                print("\t\t" + ret.stdout.decode().replace("\n", "\n\t\t"))
+        except Exception as e:
+            tested_repo.checkout("compileOrDieBackup")  # Revert to head commit
+            print(f"Failed compile-or-die testing in commit {commit}")
+            exit(1)
+    exit(0)
+
+
 # Debugging this with PyCharm is a no no. It refuses to work hanging indefinitely
 def sudo_command(command: list, password: str):
     # Run command and feed the sudo password
@@ -1878,6 +2009,10 @@
     if ns3_modules is None:
         project_not_configured()
 
+    # Entry point for compile-or-die
+    if args.compile_or_die[0] and args.compile_or_die[1]:
+        compile_or_die(*args.compile_or_die)
+
     # We could also replace the "ns3-" prefix used in .lock-ns3 with the "lib" prefix currently used in cmake
     ns3_modules = [module.replace("ns3-", "") for module in ns3_modules]
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/scratch/CMakeLists.txt ns-3.46/scratch/CMakeLists.txt
--- ns-3.45/scratch/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/scratch/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -40,17 +40,7 @@
   string(REPLACE "/" "_" scratch_dirname "${scratch_dirname}")
 
   # Get source name
-  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.14.0")
-    get_filename_component(scratch_name ${scratch_src} NAME_WLE)
-  else()
-    get_filename_component(scratch_name ${scratch_src} NAME)
-    string(FIND "${scratch_name}" "." ext_position REVERSE)
-    if(${ext_position} EQUAL -1)
-      message(FATAL_ERROR "Source file has no extension: ${scratch_src}")
-    else()
-      string(SUBSTRING "${scratch_name}" 0 ${ext_position} scratch_name)
-    endif()
-  endif()
+  get_filename_component(scratch_name ${scratch_src} NAME_WLE)
 
   set(target_prefix scratch_)
   if(scratch_dirname)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/antenna/examples/adjacency-matrix-example.cc ns-3.46/src/antenna/examples/adjacency-matrix-example.cc
--- ns-3.45/src/antenna/examples/adjacency-matrix-example.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/antenna/examples/adjacency-matrix-example.cc	2025-10-01 18:46:32.000000000 -0700
@@ -98,7 +98,7 @@
                 }
                 else
                 {
-                    routeMap[{i, j}] = {(int)i};
+                    routeMap[{i, j}] = std::vector<int>{(int)i};
                 }
             }
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/antenna/model/circular-aperture-antenna-model.cc ns-3.46/src/antenna/model/circular-aperture-antenna-model.cc
--- ns-3.45/src/antenna/model/circular-aperture-antenna-model.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/antenna/model/circular-aperture-antenna-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -20,7 +20,7 @@
 #include "ns3/double.h"
 #include "ns3/log.h"
 
-#include <math.h>
+#include <cmath>
 
 /**
  * @file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/aodv/model/aodv-routing-protocol.cc ns-3.46/src/aodv/model/aodv-routing-protocol.cc
--- ns-3.45/src/aodv/model/aodv-routing-protocol.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/aodv/model/aodv-routing-protocol.cc	2025-10-01 18:46:32.000000000 -0700
@@ -13,11 +13,6 @@
  * Authors: Elena Buchatskaia <borovkovaes@iitp.ru>
  *          Pavel Boyko <boyko@iitp.ru>
  */
-#define NS_LOG_APPEND_CONTEXT                                                                      \
-    if (m_ipv4)                                                                                    \
-    {                                                                                              \
-        std::clog << "[node " << m_ipv4->GetObject<Node>()->GetId() << "] ";                       \
-    }
 
 #include "aodv-routing-protocol.h"
 
@@ -38,6 +33,13 @@
 #include <algorithm>
 #include <limits>
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT                                                                      \
+    if (m_ipv4)                                                                                    \
+    {                                                                                              \
+        std::clog << "[node " << m_ipv4->GetObject<Node>()->GetId() << "] ";                       \
+    }
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/applications/model/three-gpp-http-variables.cc ns-3.46/src/applications/model/three-gpp-http-variables.cc
--- ns-3.45/src/applications/model/three-gpp-http-variables.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/applications/model/three-gpp-http-variables.cc	2025-10-01 18:46:32.000000000 -0700
@@ -13,7 +13,7 @@
 #include "ns3/log.h"
 #include "ns3/uinteger.h"
 
-#include <math.h>
+#include <cmath>
 
 NS_LOG_COMPONENT_DEFINE("ThreeGppHttpVariables");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/buildings/doc/Makefile ns-3.46/src/buildings/doc/Makefile
--- ns-3.45/src/buildings/doc/Makefile	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/buildings/doc/Makefile	2025-10-01 18:46:32.000000000 -0700
@@ -1,6 +1,4 @@
-EPSTOPDF = epstopdf
-DIA = dia
-CONVERT = convert -density 300
+include $(CURDIR)/../../../doc/sphinx/defines.mk
 
 SOURCE = source
 FIGURES = $(SOURCE)/figures
@@ -39,15 +37,7 @@
 	$(EPSTOPDF) $< -o=$@
 	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi
 
-# You can set these variables from the command line.
-SPHINXOPTS    = -W --keep-going
-SPHINXBUILD   = sphinx-build
-PAPER         =
-BUILDDIR      = build
-
 # Internal variables.
-PAPEROPT_a4     = -D latex_paper_size=a4
-PAPEROPT_letter = -D latex_paper_size=letter
 ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) $(SOURCE)
 
 .PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/buildings/model/buildings-channel-condition-model.cc ns-3.46/src/buildings/model/buildings-channel-condition-model.cc
--- ns-3.45/src/buildings/model/buildings-channel-condition-model.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/buildings/model/buildings-channel-condition-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -181,4 +181,4 @@
     return 0;
 }
 
-} // end namespace ns3
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/buildings/model/random-walk-2d-outdoor-mobility-model.h ns-3.46/src/buildings/model/random-walk-2d-outdoor-mobility-model.h
--- ns-3.45/src/buildings/model/random-walk-2d-outdoor-mobility-model.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/buildings/model/random-walk-2d-outdoor-mobility-model.h	2025-10-01 18:46:32.000000000 -0700
@@ -61,6 +61,12 @@
         MODE_TIME
     };
 
+    // Inherited from MobilityModel
+    Ptr<MobilityModel> Copy() const override
+    {
+        return CreateObject<RandomWalk2dOutdoorMobilityModel>(*this);
+    }
+
   private:
     /**
      * @brief Performs the rebound of the node if it reaches a boundary
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/buildings/model/three-gpp-v2v-channel-condition-model.cc ns-3.46/src/buildings/model/three-gpp-v2v-channel-condition-model.cc
--- ns-3.45/src/buildings/model/three-gpp-v2v-channel-condition-model.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/buildings/model/three-gpp-v2v-channel-condition-model.cc	2025-10-01 18:46:32.000000000 -0700
@@ -202,4 +202,4 @@
     return cond;
 }
 
-} // end namespace ns3
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/buildings/test/buildings-channel-condition-model-test.cc ns-3.46/src/buildings/test/buildings-channel-condition-model-test.cc
--- ns-3.45/src/buildings/test/buildings-channel-condition-model-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/buildings/test/buildings-channel-condition-model-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -104,7 +104,7 @@
 
     Ptr<BuildingsChannelConditionModel> condModel = CreateObject<BuildingsChannelConditionModel>();
 
-    Ptr<Building> building = Create<Building>();
+    auto building = CreateObject<Building>();
     building->SetNRoomsX(1);
     building->SetNRoomsY(1);
     building->SetNFloors(1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/buildings/test/buildings-penetration-loss-pathloss-test.cc ns-3.46/src/buildings/test/buildings-penetration-loss-pathloss-test.cc
--- ns-3.45/src/buildings/test/buildings-penetration-loss-pathloss-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/buildings/test/buildings-penetration-loss-pathloss-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -174,7 +174,7 @@
     // create the factory for the propagation loss model
     ObjectFactory propModelFactory;
 
-    Ptr<Building> building = Create<Building>();
+    auto building = CreateObject<Building>();
     building->SetExtWallsType(Building::ExtWallsType_t::ConcreteWithWindows);
     building->SetNRoomsX(1);
     building->SetNRoomsY(1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc ns-3.46/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc
--- ns-3.45/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc	2025-10-01 18:46:32.000000000 -0700
@@ -136,7 +136,7 @@
     Ptr<MobilityModel> b = CreateObject<ConstantPositionMobilityModel>();
     nodes.Get(1)->AggregateObject(b);
 
-    Ptr<Building> building = Create<Building>();
+    auto building = CreateObject<Building>();
     building->SetNRoomsX(1);
     building->SetNRoomsY(1);
     building->SetNFloors(1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/click/model/ipv4-l3-click-protocol.cc ns-3.46/src/click/model/ipv4-l3-click-protocol.cc
--- ns-3.45/src/click/model/ipv4-l3-click-protocol.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/click/model/ipv4-l3-click-protocol.cc	2025-10-01 18:46:32.000000000 -0700
@@ -274,18 +274,6 @@
 }
 
 void
-Ipv4L3ClickProtocol::SetWeakEsModel(bool model)
-{
-    m_strongEndSystemModel = !model;
-}
-
-bool
-Ipv4L3ClickProtocol::GetWeakEsModel() const
-{
-    return !m_strongEndSystemModel;
-}
-
-void
 Ipv4L3ClickProtocol::SetStrongEndSystemModel(bool model)
 {
     m_strongEndSystemModel = model;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/click/model/ipv4-l3-click-protocol.h ns-3.46/src/click/model/ipv4-l3-click-protocol.h
--- ns-3.45/src/click/model/ipv4-l3-click-protocol.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/click/model/ipv4-l3-click-protocol.h	2025-10-01 18:46:32.000000000 -0700
@@ -257,13 +257,6 @@
     void SetIpForward(bool forward) override;
     bool GetIpForward() const override;
 
-    /** @copydoc Ipv4::SetWeakEsModel */
-    NS_DEPRECATED_3_41("Use SetStrongEndSystemModel instead")
-    void SetWeakEsModel(bool model) override;
-    /** @copydoc Ipv4::GetWeakEsModel */
-    NS_DEPRECATED_3_41("Use GetStrongEndSystemModel instead")
-    bool GetWeakEsModel() const override;
-
     void SetStrongEndSystemModel(bool model) override;
     bool GetStrongEndSystemModel() const override;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/config-store/model/display-functions.h ns-3.46/src/config-store/model/display-functions.h
--- ns-3.45/src/config-store/model/display-functions.h	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/config-store/model/display-functions.h	2025-10-01 18:46:32.000000000 -0700
@@ -228,6 +228,6 @@
                                              GtkTreePath* path,
                                              GtkTreeIter* iter,
                                              gpointer data);
-} // end namespace ns3
+} // namespace ns3
 
 #endif
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/config-store/model/model-node-creator.cc ns-3.46/src/config-store/model/model-node-creator.cc
--- ns-3.45/src/config-store/model/model-node-creator.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/config-store/model/model-node-creator.cc	2025-10-01 18:46:32.000000000 -0700
@@ -127,4 +127,4 @@
     g_free(iter);
     m_iters.pop_back();
 }
-} // end namespace ns3
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/config-store/model/model-typeid-creator.cc ns-3.46/src/config-store/model/model-typeid-creator.cc
--- ns-3.45/src/config-store/model/model-typeid-creator.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/config-store/model/model-typeid-creator.cc	2025-10-01 18:46:32.000000000 -0700
@@ -71,4 +71,4 @@
 {
     Remove();
 }
-} // end namespace ns3
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/CMakeLists.txt ns-3.46/src/core/CMakeLists.txt
--- ns-3.45/src/core/CMakeLists.txt	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
@@ -349,4 +349,5 @@
   HEADER_FILES ${header_files}
   LIBRARIES_TO_LINK ${libraries_to_link}
   TEST_SOURCES ${test_sources}
+  GENERATE_EXPORT_HEADER
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/examples/empirical-random-variable-example.cc ns-3.46/src/core/examples/empirical-random-variable-example.cc
--- ns-3.45/src/core/examples/empirical-random-variable-example.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/examples/empirical-random-variable-example.cc	2025-10-01 18:46:32.000000000 -0700
@@ -200,14 +200,14 @@
     // Create the ERV in sampling mode
     Ptr<EmpiricalRandomVariable> erv = CreateObject<EmpiricalRandomVariable>();
 
-    //                          // Expectation for bin
-    erv->CDF(0.0, 0.0 / 15.0);  // 0
-    erv->CDF(0.2, 1.0 / 15.0);  // 0.2 1/15  =  2/150
-    erv->CDF(0.4, 3.0 / 15.0);  // 0.4 2/15  =  8/150
-    erv->CDF(0.6, 4.0 / 15.0);  // 0.6 1/15  =  6/150
-    erv->CDF(0.8, 7.0 / 15.0);  // 0.8 3/15  = 24/150
-    erv->CDF(1.0, 9.0 / 15.0);  // 1.0 2/15  = 20/150
-    erv->CDF(1.0, 15.0 / 15.0); // 1.0 6/15  = 60/150  <avg> = 120/150 = 0.8
+    //                         // Expectation for bin
+    erv->CDF(0.0, 0.0);        // 0
+    erv->CDF(0.2, 1.0 / 15.0); // 0.2 1/15  =  2/150
+    erv->CDF(0.4, 3.0 / 15.0); // 0.4 2/15  =  8/150
+    erv->CDF(0.6, 4.0 / 15.0); // 0.6 1/15  =  6/150
+    erv->CDF(0.8, 7.0 / 15.0); // 0.8 3/15  = 24/150
+    erv->CDF(1.0, 9.0 / 15.0); // 1.0 2/15  = 20/150
+    erv->CDF(1.0, 1.0);        // 1.0 6/15  = 60/150  <avg> = 120/150 = 0.8
 
     if (single)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/examples/main-ptr.cc ns-3.46/src/core/examples/main-ptr.cc
--- ns-3.45/src/core/examples/main-ptr.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/examples/main-ptr.cc	2025-10-01 18:46:32.000000000 -0700
@@ -26,6 +26,12 @@
 class PtrExample : public Object
 {
   public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
     /** Constructor. */
     PtrExample();
     /** Destructor. */
@@ -34,6 +40,16 @@
     void Method();
 };
 
+NS_OBJECT_ENSURE_REGISTERED(PtrExample);
+
+TypeId
+PtrExample::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::PtrExample").SetParent<Object>().SetGroupName("Core").HideFromDocumentation();
+    return tid;
+}
+
 PtrExample::PtrExample()
 {
     std::cout << "PtrExample constructor" << std::endl;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/core/examples/main-random-variable-stream.cc ns-3.46/src/core/examples/main-random-variable-stream.cc
--- ns-3.45/src/core/examples/main-random-variable-stream.cc	2025-06-01 20:34:45.000000000 -0700
+++ ns-3.46/src/core/examples/main-random-variable-stream.cc	2025-10-01 18:46:32.000000000 -0700
@@ -268,12 +268,12 @@
         plot.AppendExtra("set xrange [*:*]");
 
         auto x = CreateObject<EmpiricalRandomVariable>();
-        x->CDF(0.0, 0.0 / 15.0);
+        x->CDF(0.0, 0.0);
         x->CDF(0.2, 1.0 / 15.0);
         x->CDF(0.4, 3.0 / 15.0);
         x->CDF(0.6, 6.0 / 15.0);
         x->CDF(0.8, 10.0 / 15.0);
-        x->CDF(1.0, 15.0 / 15.0);
+        x->CDF(1.0, 1.0);
 
         plot.AddDataset(
             Histogram(x, probes, precision, "EmpiricalRandomVariable (Sampling)", true));
